;Nick Editor
;=================


alias abbrcomplete {
  tokenize 32 $1-
  var %read = $read -nt -s [ $+ [ $iif($left($1,1) == ",' $+ $1 $+ ',$1) ] ] $mircdirini\short.mrc, %result
  if (%read == $null) { return $1- }
  while (%read) {
    var %word = $gettok(%read,1,32)
    %result = %result $iif(%abbr.active,%abbr.active,%color.active) $+ %abbr.bold.a $+ %abbr.underline.a $+ $left(%word,1) $+  $+ $iif(%abbr.inactive,%abbr.inactive,%color.inactive) $+ %abbr.bold.i $+ %abbr.underline.i $+ $right(%word,-1) $+ 
    %read = $deltok(%read,1,32)
  }
  return %result $2-
}



alias abbredit dialog -m Abbr Abbr

alias fillAbbr {
  did -r Abbr 7
  set %dialog.current 1
  :next
  unset %dialog.temp
  %dialog.temp = [ $read -ntl $+ [ %dialog.current ] $mircdirini\short.mrc ]
  if (%dialog.current <= $lines($mircdirini\short.mrc)) {
    /tokenize 32 %dialog.temp
    /did -o Abbr 7 [ %dialog.current ] $lower($1)
    inc %dialog.current 1
    goto next
  }
  unset %dialog.temp

}

alias PopupError {
  set %dialog.error $$1-
  dialog -m AbbrError AbbrError
}

on *:dialog:Abbr:init:*: {
  if ($did == 0) fillAbbr
}

on *:dialog:Abbr:dclick:*: {
  tokenize 32 [ $read [ -ntl $+ [ $did($did).sel ] ] $mircdirini\short.mrc ]
  did -o $dname 2 1 $1
  did -o $dname 4 1 $2-
}

on *:dialog:Abbr:sclick:*: {
  if (($did == 12) || ($did == 11)) {
    did -r $dname 2
    did -r $dname 4
  }
  if (($did(Abbr,2).text != $strip($did(Abbr,2).text)) || ($did(Abbr,4).text != $strip($did(Abbr,4).text))) {
    popuperror No Colors/Bold Allowed
    halt
  }
  if (($chr(44) isin $did(Abbr,2).text) || ($chr(44) isin $did(Abbr,4).text) || ($chr(40) isin $did(Abbr,2).text) || ($chr(40) isin $did(Abbr,4).text) || $&
  ($chr(41) isin $did(Abbr,2).text) || ($chr(41) isin $did(Abbr,4).text) ||  ($chr(91) isin $did(Abbr,2).text) || ($chr(91) isin $did(Abbr,4).text) || $&
  ($chr(93) isin $did(Abbr,2).text) || ($chr(93) isin $did(Abbr,4).text)) {
    popuperror No Comma's or Brackets please
    halt
  }
  if ($did == 5) {
    tokenize 32 $did(2).text
    if ($2 != $null) {
      popuperror There may not be spaces in the trigger.
      halt
    }
    tokenize 32 $did(4).text
    if ($1- == $null) {
      popuperror You must speficy a response for the trigger: $did(2).text
      halt
    }

    set %dialog.linenum 1
    :okay
    tokenize 32 $read [ -ntl $+ [ %dialog.linenum ] $mircdirini\short.mrc ]
    if ($1 == $did(Abbr,2).text) {
      write [ -dl $+ [ %dialog.linenum ] $mircdirini\short.mrc ]
      goto con
    }
    elseif ($1- != $null)  {
      inc %dialog.linenum 1
      goto okay
    }
    :con

    set %dialog.current 1
    :next
    tokenize 32 [ $read [ -ntl $+ [ %dialog.current ] ] $mircdirini\short.mrc ]
    if ( $iif( [ $lower( [ $1 ] ) ] > [ $lower( [ $did(2).text ] ) ] , [ $true ] ) ) {
      write [ -il $+ [ %dialog.current ] $mircdirini\short.mrc [ $strip( [ $did(2).text $did(4).text ] ) ] ]
      goto end
    }
    elseif (%dialog.current >= $lines($mircdirini\short.mrc)) {
      write [ -i $mircdirini\short.mrc [ $strip( [ $did(2).text $did(4).text ] ) ] ]
      goto end
    }
    else {
      inc %dialog.current 1
      goto next
    }
    :end
    fillAbbr

  }
  if ($did == 6) {
    if ($did(Abbr,2).text == $null) {
      popuperror Nothing to Delete.
      halt
    }
    set %dialog.linenum 1
    :okay2
    tokenize 32 $read [ -ntl $+ [ %dialog.linenum ] $mircdirini\short.mrc ]
    if ($1 == $did(Abbr,2).text) {
      write [ -dl $+ [ %dialog.linenum ] $mircdirini\short.mrc ]
      goto con2
    }
    elseif ($1- != $null)  {
      inc %dialog.linenum 1
      goto okay2
    }
    :con2

    fillAbbr
  }

}

on *:dialog:AbbrError:*:*: {
  did -a $dname 1 %dialog.error
  unset %dialog.error
}

dialog AbbrError {
  title "Please Note..."
  size -1 -1 170 80

  text "", 1, 10 10 150 100,center
  button "Ok", 2, 55 60 60 20, cancel

}


dialog Abbr {
  title "Abbreviation Completion"
  size -1 -1 330 225

  text "Trigger:", 1, 10 12 50 14 
  edit "", 2, 65 10 90 20, 
  text "Response:", 3, 10 32 50 14 
  edit "", 4, 65 30 250 20, 
  button "Clear", 12, 160 10 50 20 
  button "Save", 5, 215 10 50 20 
  button "Delete", 6, 270 10 50 20 
  list 7, 10 55 90 160, size
  text "Abbreviation Editor:", 8, 105 55 160 20
  text "To edit an existing abbreviation completion, simply double click the desired abbreviation, edit the results and click save.", 9, 105 75 200 50
  text "To add a new item.  Simply add it into the edit box and the response box and click save. (To delete, just click delete)", 10, 105 135 200 60
  button "Exit Editor", 11, 260 200 60 20, cancel
}
